// SimpleTextFileDoc.h : interface of the CSimpleTextFileDoc class
//

#include "TextObject.h"
#pragma once


class CSimpleTextFileDoc : public CDocument
{
protected: // create from serialization only
	CSimpleTextFileDoc();
	DECLARE_DYNCREATE(CSimpleTextFileDoc)

// Attributes
public:
	CTypedPtrList<CObList, CTextObject*> m_TextObjectList;
	void AddTextObject(CTextObject* pObj);		// Add an object to the list     
	void DeleteTextObject(CTextObject* pObj);	// Delete an object
	POSITION GetListHeadPosition() { return m_TextObjectList.GetHeadPosition(); }	// Return list head POSITION value
	CTextObject* GetNext(POSITION& aPos) { return m_TextObjectList.GetNext(aPos); }	// Return current object pointer

// Operations
public:

// Overrides
public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual void DeleteContents();

// Implementation
public:
	virtual ~CSimpleTextFileDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
public:
	afx_msg void OnFileImport();
	afx_msg void OnFileExport();
	DECLARE_MESSAGE_MAP()
};


