// SimpleTextFileView.cpp : implementation of the CSimpleTextFileView class
//

#include "stdafx.h"
#include "SimpleTextFile.h"

#include "SimpleTextFileDoc.h"
#include "SimpleTextFileView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CSimpleTextFileView

IMPLEMENT_DYNCREATE(CSimpleTextFileView, CView)

BEGIN_MESSAGE_MAP(CSimpleTextFileView, CView)
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, &CView::OnFilePrintPreview)
	ON_COMMAND(ID_COLOR_RED, &CSimpleTextFileView::OnColorRed)
	ON_COMMAND(ID_COLOR_GREEN, &CSimpleTextFileView::OnColorGreen)
	ON_COMMAND(ID_COLOR_BLUE, &CSimpleTextFileView::OnColorBlue)
	ON_COMMAND(ID_COLOR_BLACK, &CSimpleTextFileView::OnColorBlack)
	ON_WM_CHAR()
	ON_WM_LBUTTONDOWN()
	ON_WM_SETFOCUS()
	ON_WM_KILLFOCUS()
END_MESSAGE_MAP()		

// CSimpleTextFileView construction/destruction

CSimpleTextFileView::CSimpleTextFileView()
{
	// TODO: add construction code here
	m_TextObject = NULL;
	m_Color = RGB(0, 0, 0);
	m_Point = CPoint(0, 0);
}

CSimpleTextFileView::~CSimpleTextFileView()
{
	if (m_TextObject) {
		delete m_TextObject;
		m_TextObject = NULL;
	}
}

BOOL CSimpleTextFileView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	// TODO:  Add your specialized creation code here
	return CView::PreCreateWindow(cs);
}

// CSimpleTextFileView drawing

void CSimpleTextFileView::OnDraw(CDC* pDC)
{
	CSimpleTextFileDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: add draw code for native data here

	// ťƮ  ü Ʈ 鼭,  TextObject ׸.
	POSITION aPos = pDoc->GetListHeadPosition();
	CTextObject* pObj = 0;				// Store for a shape object pointer
	while (aPos) {						// Loop while aPos is not null
		pObj = pDoc->GetNext(aPos);		// Get the current shape object pointer
		pObj->Draw(pDC);
	}
}

// CSimpleTextFileView printing

BOOL CSimpleTextFileView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CSimpleTextFileView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CSimpleTextFileView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

// CSimpleTextFileView diagnostics

#ifdef _DEBUG
void CSimpleTextFileView::AssertValid() const
{
	CView::AssertValid();
}

void CSimpleTextFileView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CSimpleTextFileDoc* CSimpleTextFileView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSimpleTextFileDoc)));
	return (CSimpleTextFileDoc*)m_pDocument;
}
#endif //_DEBUG


// CSimpleTextFileView message handlers
void CSimpleTextFileView::OnColorRed() 
{
	m_Color = RGB(255, 0, 0);
}

void CSimpleTextFileView::OnColorGreen() 
{
	m_Color = RGB(0, 255, 0);
}

void CSimpleTextFileView::OnColorBlue() 
{
	m_Color = RGB(0, 0, 255);
}

void CSimpleTextFileView::OnColorBlack() 
{
	m_Color = RGB(0, 0, 0);
}

void CSimpleTextFileView::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	HideCaret();			// ĳ .

	// ̹ m_TextObject ִٸ,  ؽƮ ڸ ߰ϰ ׷ش.
	if (m_TextObject) {
		m_Point.x += 30;	// ڰ ߰Ǵ ŭ, ĳ ġ  ش.

		CClientDC dc(this);	// DC is for this view
		m_TextObject->Append((char)nChar);
		m_TextObject->Draw(&dc);
	}

	SetCaretPos(m_Point);	// ġ 缳
	ShowCaret();			// ĳ ٽ δ.

	CView::OnChar(nChar, nRepCnt, nFlags);
}

void CSimpleTextFileView::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default

	// ̹ m_TextObject ִٸ, Ʈ ߰ϰ ͸ NULL .
	if (m_TextObject) {
		GetDocument()->AddTextObject(m_TextObject);
		GetDocument()->UpdateAllViews(0,0,m_TextObject);	// Tell all the views
		m_TextObject = NULL;								// Reset the text object pointer
	}

	// ο TextObject Ѵ.
	m_Point = point;
	SetCaretPos(m_Point);	// ġ 缳
	ShowCaret();			// ĳ ٽ δ.
	m_TextObject = new CTextObject("", m_Point, m_Color);

	CView::OnLButtonDown(nFlags, point);
}

void CSimpleTextFileView::OnSetFocus(CWnd* pOldWnd)
{
	CView::OnSetFocus(pOldWnd);

	// TODO: Add your message handler code here
	CreateSolidCaret(10, 40); // ĳ 
}

void CSimpleTextFileView::OnKillFocus(CWnd* pNewWnd)
{
	CView::OnKillFocus(pNewWnd);

	// TODO: Add your message handler code here
	HideCaret();		// ĳ .
	::DestroyCaret();	// ĳ ıѴ.
}
